<script>
import authApi from "../api/firebaseAuthApi";

export default {
  data() {
    return {
      email: "",
      password: "",
      confirmPassword: "",
    };
  },
  props: {
    isRegister: false,
  },
  computed: {
    btnText() {
      return this.isRegister ? "Registrarse" : "Logearse";
    },
    equalPasswords() {
      return this.password == this.confirmPassword;
    },
  },
  methods: {
    botonPresionado() {
      let bodyPayload = {
        email: this.email,
        password: this.password,
        returnSecureToken: true,
      };

      if (this.isRegister) {
        if (this.equalPasswords) {
          this.registro(bodyPayload);
        } else {
          alert("Las contraseñas deben de coincidir.");
        }
      } else {
        this.login(bodyPayload);
      }
    },
    registro(payload) {
      authApi
        .post("/accounts:signUp", payload)
        .then((resp) => console.log(resp));
    },
    login(payload) {
      authApi
        .post("/accounts:signInWithPassword", payload)
        .then((resp) => console.log(resp));
    },
  },
};
</script>

<template>
  <div class="loginContainer">
    <div class="inputContainer">
      <h3>Email</h3>
      <input
        class="input"
        type="email"
        v-model="email"
        placeholder="email@ejemplo.com"
      />
      <hr class="shrinkBorder" />
      <br />
    </div>
    <div class="inputContainer">
      <h3>Contraseña</h3>
      <input class="input" type="password" v-model="password" />
      <hr class="shrinkBorder" />
      <br />
    </div>
    <div v-if="isRegister" class="inputContainer">
      <h3>Repetir contraseña</h3>
      <input class="input" type="password" v-model="confirmPassword" />
      <hr class="shrinkBorder" />
      <br />
    </div>
    <br />
    <button @click="botonPresionado">{{ btnText }}</button>
    <br />
    <span v-if="isRegister"
      >¿Ya estás registrado? Haz click
      <router-link :to="{ name: 'login' }">aquí</router-link> para
      logearte.</span
    >
    <span v-else
      >¿Aún no estás registrado? Haz click
      <router-link :to="{ name: 'register' }">aquí</router-link> para
      registrarte.</span
    >
  </div>
</template>

<style scoped>
.loginContainer {
  display: flex;
  flex-direction: column;
  width: 100%;
}

.inputContainer {
  display: flex;
  flex-direction: column;
  width: 100%;
}

input {
  outline: none;
  border: none;
  padding: 3px;
  background-color: rgb(239, 239, 239);
}

.shrinkBorder {
  border: none;
  height: 2px;
  background-color: rgb(179, 0, 179);
  transition: 0.3s ease-in-out;
  align-self: center;
  width: 100%;
}

.input:focus + .shrinkBorder {
  width: 75%;
}

button {
  background-color: rgb(179, 0, 179);
  color: white;
  border: none;
  outline: none;
  padding: 7px;
  border-radius: 10px;
  width: 50%;
  align-self: center;
  cursor: pointer;
  transition: 0.2s ease-in-out;
}

button:hover {
  background-color: rgb(135, 0, 135);
}

button:focus:hover {
  outline: 3px rgba(187, 0, 187, 0.503) solid;
}
</style>
